package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.ench.EnchModule;
import dev.shadowsoffire.placebo.util.PlaceboTaskQueue;
import java.util.function.BooleanSupplier;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.ToolActions;
import net.minecraftforge.event.level.BlockEvent;

public class ChainsawEnchant extends Enchantment {
  public ChainsawEnchant() {
    super(Enchantment.Rarity.VERY_RARE, EnchModule.AXE, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
  }
  
  public int m_6586_() {
    return 1;
  }
  
  public int m_6183_(int level) {
    return 55;
  }
  
  public int m_6175_(int enchantmentLevel) {
    return 200;
  }
  
  public Component m_44700_(int level) {
    return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_GREEN);
  }
  
  public boolean canApplyAtEnchantingTable(ItemStack stack) {
    return (stack.canPerformAction(ToolActions.AXE_DIG) || super.canApplyAtEnchantingTable(stack));
  }
  
  public void chainsaw(BlockEvent.BreakEvent e) {
    Player player = e.getPlayer();
    Level level = player.m_9236_();
    ItemStack stack = player.m_21205_();
    int enchLevel = stack.getEnchantmentLevel(this);
    if (player.getClass() == ServerPlayer.class && enchLevel > 0 && !level.f_46443_ && isTree(level, e.getPos(), e.getState()) && 
      !(player.m_150110_()).f_35937_)
      PlaceboTaskQueue.submitTask("apotheosis:chainsaw_task", (BooleanSupplier)new ChainsawTask(player.m_20148_(), stack, level, e.getPos())); 
  }
  
  private boolean isTree(Level level, BlockPos pos, BlockState state) {
    if (!state.m_204336_(BlockTags.f_13106_))
      return false; 
    while (state.m_204336_(BlockTags.f_13106_))
      state = level.m_8055_(pos = pos.m_7494_()); 
    for (BlockPos p : BlockPos.m_121940_(pos.m_7918_(-2, -2, -2), pos.m_7918_(2, 2, 2))) {
      if (level.m_8055_(p).m_204336_(BlockTags.f_13035_))
        return true; 
    } 
    return false;
  }
}
